<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageCalendarPriceItems ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageCalendarPriceItems extends AbstractStructArrayBase
{
    /**
     * The PackageCalendarPriceItems
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageCalendarPriceItems[]
     */
    public $PackageCalendarPriceItems;
    /**
     * Constructor method for ArrayOfJP_PackageCalendarPriceItems
     * @uses ArrayOfJP_PackageCalendarPriceItems::setPackageCalendarPriceItems()
     * @param \StructType\JP_PackageCalendarPriceItems[] $packageCalendarPriceItems
     */
    public function __construct(array $packageCalendarPriceItems = array())
    {
        $this
            ->setPackageCalendarPriceItems($packageCalendarPriceItems);
    }
    /**
     * Get PackageCalendarPriceItems value
     * @return \StructType\JP_PackageCalendarPriceItems[]|null
     */
    public function getPackageCalendarPriceItems()
    {
        return $this->PackageCalendarPriceItems;
    }
    /**
     * This method is responsible for validating the values passed to the setPackageCalendarPriceItems method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPackageCalendarPriceItems method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePackageCalendarPriceItemsForArrayConstraintsFromSetPackageCalendarPriceItems(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem instanceof \StructType\JP_PackageCalendarPriceItems) {
                $invalidValues[] = is_object($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) ? get_class($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem) : sprintf('%s(%s)', gettype($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem), var_export($arrayOfJP_PackageCalendarPriceItemsPackageCalendarPriceItemsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PackageCalendarPriceItems property can only contain items of type \StructType\JP_PackageCalendarPriceItems, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PackageCalendarPriceItems value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageCalendarPriceItems[] $packageCalendarPriceItems
     * @return \ArrayType\ArrayOfJP_PackageCalendarPriceItems
     */
    public function setPackageCalendarPriceItems(array $packageCalendarPriceItems = array())
    {
        // validation for constraint: array
        if ('' !== ($packageCalendarPriceItemsArrayErrorMessage = self::validatePackageCalendarPriceItemsForArrayConstraintsFromSetPackageCalendarPriceItems($packageCalendarPriceItems))) {
            throw new \InvalidArgumentException($packageCalendarPriceItemsArrayErrorMessage, __LINE__);
        }
        $this->PackageCalendarPriceItems = $packageCalendarPriceItems;
        return $this;
    }
    /**
     * Add item to PackageCalendarPriceItems value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageCalendarPriceItems $item
     * @return \ArrayType\ArrayOfJP_PackageCalendarPriceItems
     */
    public function addToPackageCalendarPriceItems(\StructType\JP_PackageCalendarPriceItems $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageCalendarPriceItems) {
            throw new \InvalidArgumentException(sprintf('The PackageCalendarPriceItems property can only contain items of type \StructType\JP_PackageCalendarPriceItems, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PackageCalendarPriceItems[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageCalendarPriceItems|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PackageCalendarPriceItems
     */
    public function getAttributeName()
    {
        return 'PackageCalendarPriceItems';
    }
}
